#!/usr/bin/env node
"use strict";
/**
 * hoisted-package-json
 * Generate the package.json used during a hoisted bootstrap
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const fs = __importStar(require("fs"));
const t = __importStar(require("io-ts"));
const E = __importStar(require("fp-ts/Either"));
const T = __importStar(require("fp-ts/Task"));
const TE = __importStar(require("fp-ts/TaskEither"));
const Console = __importStar(require("fp-ts/Console"));
const PathReporter = __importStar(require("io-ts/lib/PathReporter"));
const Apply_1 = require("fp-ts/Apply");
const function_1 = require("fp-ts/function");
const io_ts_docopt_1 = require("io-ts-docopt");
const PackageJsonDependencies_1 = require("@typescript-tools/io-ts/dist/lib/PackageJsonDependencies");
const StringifiedJSON_1 = require("@typescript-tools/io-ts/dist/lib/StringifiedJSON");
const monorepo_root_1 = require("@typescript-tools/monorepo-root");
const hoisted_packages_1 = require("@typescript-tools/hoisted-packages");
const docstring = `
Usage:
    hoisted-package-json

Options:
`;
const CommandLineOptions = t.type({});
const err = function_1.identity;
const readFile = (filename) => TE.tryCatch(() => __awaiter(void 0, void 0, void 0, function* () {
    return new Promise((resolve, reject) => fs.readFile(filename, 'utf8', (error, data) => error !== null && error !== undefined
        ? reject(error)
        : resolve(data)));
}), function_1.flow(E.toError, (error) => err({ type: 'unable to read file', filename, error })));
const decodeDocopt = function_1.flow(io_ts_docopt_1.decodeDocopt, E.mapLeft(function_1.flow((errors) => PathReporter.failure(errors).join('\n'), (error) => err({ type: 'docopt decode', error }))), TE.fromEither);
const monorepoRoot = function_1.flow(monorepo_root_1.monorepoRoot, E.mapLeft(err), TE.fromEither);
const hoistedPackages = function_1.flow(hoisted_packages_1.hoistedPackages, TE.mapLeft(err));
const readRootPackageJson = (root) => function_1.pipe(path.resolve(root, 'package.json'), readFile, TE.chain(function_1.flow(StringifiedJSON_1.StringifiedJSON(PackageJsonDependencies_1.PackageJsonDependencies).decode.bind(null), E.mapLeft(function_1.flow((errors) => PathReporter.failure(errors).join('\n'), (error) => err({
    type: 'unexpected contents in top-level package.json',
    error,
}))), TE.fromEither)));
const hoistedPackageJson = (hoisted, manifest) => Object.assign({}, manifest, {
    devDependencies: undefined,
    peerDependencies: undefined,
    optionalDependencies: undefined,
    dependencies: Object.fromEntries(hoisted),
});
const stringifyJson = (json) => function_1.pipe(E.tryCatch(() => JSON.stringify(json, null, 2), E.toError), E.mapLeft((error) => err({ type: 'unable to stringify package.json', error })), TE.fromEither);
const main = function_1.pipe(TE.bindTo('options')(decodeDocopt(CommandLineOptions, docstring)), TE.bind('root', () => monorepoRoot()), TE.chain(({ root }) => function_1.pipe({
    hoisted: hoistedPackages(root),
    rootPackageJson: readRootPackageJson(root),
}, Apply_1.sequenceS(TE.ApplicativePar), TE.chain(({ hoisted, rootPackageJson }) => function_1.pipe(hoistedPackageJson(hoisted, rootPackageJson), stringifyJson)))), TE.fold(function_1.flow(Console.error, T.fromIO), function_1.flow(Console.log, T.fromIO)));
main();
// Local Variables:
// mode: typescript
// End:
//# sourceMappingURL=index.js.map